import { SvelteComponent } from "svelte";
import type { MenuItem } from "./types.js";
declare const __propDef: {
    props: {
        menuItems?: MenuItem[];
        isContextMenuVisible?: () => boolean;
        showContextMenu?: (event: MouseEvent | {
            target: HTMLElement;
        }, hidePrevContextMenu?: boolean, position?: {
            parentBox: HTMLElement | null;
            x: number | null;
            y: number | null;
        }) => Promise<void>;
        hideContextMenu?: () => Promise<void>;
    };
    events: {
        menuItemClicked: CustomEvent<MenuItem>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {};
    exports?: {} | undefined;
    bindings?: string | undefined;
};
export type ContextMenuMediatorProps = typeof __propDef.props;
export type ContextMenuMediatorEvents = typeof __propDef.events;
export type ContextMenuMediatorSlots = typeof __propDef.slots;
export default class ContextMenuMediator extends SvelteComponent<ContextMenuMediatorProps, ContextMenuMediatorEvents, ContextMenuMediatorSlots> {
    get isContextMenuVisible(): () => boolean;
    get showContextMenu(): (event: MouseEvent | {
        target: HTMLElement;
    }, hidePrevContextMenu?: boolean, position?: {
        parentBox: HTMLElement | null;
        x: number | null;
        y: number | null;
    }) => Promise<void>;
    get hideContextMenu(): () => Promise<void>;
}
export {};
