import { SvelteComponent } from "svelte";
import type { TreeNode } from "../common/tree.js";
import type { NodeStylerFunction } from "./types.js";
declare const __propDef: {
    props: {
        nodeLevel?: number;
        data?: TreeNode[];
        openIcon?: string;
        closeIcon?: string;
        showSelectRect?: boolean;
        nodeStyler?: NodeStylerFunction | null;
        hoverDelay?: number;
        updateNodeSelected?: (nodeId: string | null) => void;
        openNodeAtSelectRect?: (rootUlElem: HTMLUListElement) => void;
        closeNodeAtSelectRect?: (rootUlElem: HTMLUListElement) => void;
        selectNodeAtSelectRect?: (rootUlElem: HTMLUListElement) => void;
        moveSelectRectToPrevNode?: (rootUlElem: HTMLUListElement) => void;
        moveSelectRectToNextNode?: (rootUlElem: HTMLUListElement) => void;
        moveSelectRectToFirstNode?: (rootUlElem: HTMLUListElement) => void;
        moveSelectRectToLastNode?: (rootUlElem: HTMLUListElement) => void;
        removeNodeAtSelectRect?: (rootUlElem: HTMLUListElement) => void;
    };
    events: {
        mousedown: MouseEvent;
        treeNodeSelected: CustomEvent<TreeNode>;
        treeNodeHovered: CustomEvent<TreeNode>;
        treeNodeButtonClicked: CustomEvent<TreeNode>;
        treeNodeRemove: CustomEvent<TreeNode>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {};
    exports?: {} | undefined;
    bindings?: string | undefined;
};
export type TreeProps = typeof __propDef.props;
type TreeEvents_ = typeof __propDef.events;
export { TreeEvents_ as TreeEvents };
export type TreeSlots = typeof __propDef.slots;
export default class Tree extends SvelteComponent<TreeProps, TreeEvents_, TreeSlots> {
    get updateNodeSelected(): (nodeId: string | null) => void;
    get openNodeAtSelectRect(): (rootUlElem: HTMLUListElement) => void;
    get closeNodeAtSelectRect(): (rootUlElem: HTMLUListElement) => void;
    get selectNodeAtSelectRect(): (rootUlElem: HTMLUListElement) => void;
    get moveSelectRectToPrevNode(): (rootUlElem: HTMLUListElement) => void;
    get moveSelectRectToNextNode(): (rootUlElem: HTMLUListElement) => void;
    get moveSelectRectToFirstNode(): (rootUlElem: HTMLUListElement) => void;
    get moveSelectRectToLastNode(): (rootUlElem: HTMLUListElement) => void;
    get removeNodeAtSelectRect(): (rootUlElem: HTMLUListElement) => void;
}
