export interface DataProps {
    sourceComponentName: string | null;
    [key: string]: any;
}
export declare class LinkedDataStoreInfo {
    dataProps: DataProps;
    unsubscribe: () => void;
    constructor(dataProps: DataProps, unsubscribe: () => void);
}
export declare abstract class DataSink {
    linkedDataStoreInfos: LinkedDataStoreInfo[];
    abstract isCompatible(props: DataProps): boolean;
    abstract update(data: object): void;
}
export interface DataStore {
    dataProps: DataProps;
    subscribe(dataSink: DataSink, cleanUp: () => void): void;
    set(data: object): void;
}
export declare class DefaultDataStore implements DataStore {
    private store;
    dataProps: DataProps;
    constructor(dataProps: DataProps);
    subscribe(dataSink: DataSink, cleanUp?: () => void): void;
    set(data: object): void;
}
