export function createTreeNode(node = {}) {
    return {
        id: node.id ?? crypto.randomUUID(),
        name: node.name ?? null,
        open: node.open ?? true,
        children: node.children ?? [],
        data: node.data,
    };
}
export class Tree {
    root;
    constructor(tree) {
        this.root = tree;
    }
    getRoot() {
        return this.root;
    }
    traverse(callback) {
        return this.doTraverse(this.root, callback);
    }
    doTraverse(nodes, callback, level = 0) {
        for (let i = 0; i < nodes.length; ++i) {
            const node = nodes[i];
            if (callback(node, nodes, { get: () => i, set: (_i) => (i = _i) }, level)) {
                return true;
            }
            if (node.children &&
                this.doTraverse(node.children, callback, level + 1)) {
                return true;
            }
        }
        return false;
    }
}
