interface ComponentConstructor<Props = Record<string, unknown>, ReturnType = unknown> {
    new (options: {
        target: Element;
        props: Props;
    }): ReturnType;
}
export declare const getNumberOfRegisteredComponents: () => number;
export declare const getRegisteredComponentNames: () => string[];
export declare const getRegisteredComponentClasses: () => ComponentConstructor[];
export declare const getRegisteredComponent: (className: string) => ComponentConstructor | undefined;
export declare const registerComponent: (...args: [string, ComponentConstructor] | [ComponentConstructor]) => ComponentConstructor;
export declare const unregisterComponent: (className: string) => void;
export declare const createComponent: (className: string, props: Record<string, unknown>, targetElement: Element) => InstanceType<ComponentConstructor>;
export {};
